/**
 * 
 */
package org.solol.mmseg.internal;

import org.solol.mmseg.core.AlgorithmException;
import org.solol.mmseg.core.AlgorithmFactory;
import org.solol.mmseg.core.Config;
import org.solol.mmseg.core.IAlgorithm;

/**
 * @author solo L
 * 
 */
public class AlgorithmFactoryImpl extends AlgorithmFactory {

	public IAlgorithm createAlgorithm() throws AlgorithmException {
		return createAlgorithm(Config.SINGLE_WORD);
	}

	public IAlgorithm createAlgorithm(String type) throws AlgorithmException {
		if (type.equalsIgnoreCase(Config.SINGLE_WORD)) {
			return new SimpleAlgorithm();
		} else if (type.equalsIgnoreCase(Config.THREE_WORD)) {
			return new ComplexAlgorithm();
		}
		throw new AlgorithmException("Not support.");
	}
}
