/**
 * 
 */
package org.solol.mmseg.internal;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.solol.mmseg.core.IChunk;
import org.solol.mmseg.core.IRule;

/**
 * @author solo L
 * 
 */
public class SVWLRule implements IRule {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.solol.mmseg.core.IRule#invoke()
	 */
	public final IChunk[] invoke(final IChunk[] chunks) {
		SVWLRuleComparator[] orderedChunks = new SVWLRuleComparator[chunks.length];

		for (int i = 0; i < chunks.length; i++) {
			orderedChunks[i] = new SVWLRuleComparator(chunks[i]);
		}

		Arrays.sort(orderedChunks);

		int index = 0;
		double smallestVariance = orderedChunks[index].getChunk()
				.getVariance();

		List list = new ArrayList(1);
		list.add(orderedChunks[index].getChunk());

		index++;

		while (index < orderedChunks.length) {

			if (orderedChunks[index].getChunk().getVariance() == smallestVariance) {
				list.add(orderedChunks[index].getChunk());
			} else {
				break;
			}
			index++;
		}

		IChunk[] smallestVarianceChunks = new IChunk[list.size()];
		list.toArray(smallestVarianceChunks);

		return smallestVarianceChunks;
	}

	static class SVWLRuleComparator implements Comparable {

		private IChunk chunk;

		public SVWLRuleComparator(IChunk chunk) {
			this.chunk = chunk;
		}

		public IChunk getChunk() {
			return chunk;
		}

		public int compareTo(Object obj) {
			IChunk another = ((SVWLRuleComparator) obj).getChunk();
			
			double temp = chunk.getVariance() - another.getVariance();
			
			if (temp > 0D) {
				return 1;
			} else if (temp < 0D) {
				return -1;
			} else {
				return 0;
			}
		}

	}
}
