package org.solol.mmseg.test;

import org.solol.mmseg.core.AlgorithmFactory;
import org.solol.mmseg.core.Config;
import org.solol.mmseg.core.IAlgorithm;
import org.solol.mmseg.core.IWord;
import org.solol.mmseg.internal.Word;

import junit.framework.TestCase;

public class ComplexAlgorithmTest extends TestCase {
	
	private IAlgorithm algorithm;
	
	protected void setUp() throws Exception {
		algorithm = AlgorithmFactory.getFactory().createAlgorithm(Config.THREE_WORD);
	}

	protected void tearDown() throws Exception {

	}

	public final void testMMRule() {
		// MMRule -> Rule1
		String content = "眼看就要来了";
		IWord word1 = new Word("眼看",Word.CJK_WORD);
		
		IWord word = algorithm.next(content.toCharArray());
		assertEquals(word1, word);
	}
	public final void testLAWLRule() {
//		LAWLRule -> Rule2
		String content = "国际化";
		IWord word1 = new Word("国际化",Word.CJK_WORD);	
		
		IWord word = algorithm.next(content.toCharArray());
		assertEquals(word1, word);
	}
	
	public final void testSVWLRule() {
//		SVWLRule -> Rule3
		String content = "研究生命起源";
		IWord word1 = new Word("研究",Word.CJK_WORD);	
		
		IWord word = algorithm.next(content.toCharArray());
		assertEquals(word1, word);
	}
	
	public final void testLSDMFOCWRule() {
//		LSDMFOCWRule -> Rule4
		String content = "是一个";
		IWord word1 = new Word("是",Word.CJK_WORD);		
		
		IWord word = algorithm.next(content.toCharArray());
		assertEquals(word1, word);
	}

}
