/**
 * 
 */
package org.solol.mmseg.test;

import junit.framework.TestCase;

import org.solol.mmseg.core.IChunk;
import org.solol.mmseg.core.IRule;
import org.solol.mmseg.core.IWord;
import org.solol.mmseg.internal.Chunk;
import org.solol.mmseg.internal.LAWLRule;
import org.solol.mmseg.internal.Word;

/**
 * @author solo L
 * 
 */
public class LAWLRuleTest extends TestCase {
	
	IChunk chunk1;

	IChunk chunk2;

	IChunk chunk3;

	/**
	 * 
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		IWord word1 = new Word("国际化",Word.CJK_WORD);
		IWord word2 = new Word("国际",Word.CJK_WORD);
		IWord word3 = new Word("国",Word.CJK_WORD);
		IWord word4 = new Word("际",Word.CJK_WORD);
		IWord word5 = new Word("化",Word.CJK_WORD);

		chunk1 = new Chunk(new IWord[] { word1 });
		chunk2 = new Chunk(new IWord[] { word2, word5 });
		chunk3 = new Chunk(new IWord[] { word3, word4, word5 });

	}

	/**
	 * 
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
	}

	/**
	 * Test method for
	 * {@link org.solol.mmseg.internal.LAWLRule#invoke(org.solol.mmseg.core.IChunk[])}.
	 */
	public final void testInvoke() {
		IRule lawlRule = new LAWLRule();
		IChunk[] chunks = new IChunk[] { chunk1, chunk2, chunk3 };
		IChunk[] lawlChunks = lawlRule.invoke(chunks);
		assertEquals(chunk1, lawlChunks[0]);
	}

}
