package org.solol.mmseg.test;

import org.solol.mmseg.core.IChunk;
import org.solol.mmseg.core.IRule;
import org.solol.mmseg.core.IWord;
import org.solol.mmseg.internal.Chunk;
import org.solol.mmseg.internal.LSDMFOCWRule;
import org.solol.mmseg.internal.Word;

import junit.framework.TestCase;

public class LSDMFOCWRuleTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public final void testInvoke() {
		IWord word1 = new Word("主要",Word.CJK_WORD);
		IWord word2 = new Word("是",3200626,Word.CJK_WORD);
		IWord word3 = new Word("因为",Word.CJK_WORD);
		IWord word4 = new Word("主",224073,Word.CJK_WORD);
		IWord word5 = new Word("要是",Word.CJK_WORD);

		IChunk chunk1 = new Chunk(new IWord[] { word1, word2, word3 });
		IChunk chunk2 = new Chunk(new IWord[] { word4, word5, word3 });
		
		IRule lsdmfocwRule = new LSDMFOCWRule();
		IChunk[] chunks = new IChunk[] { chunk1, chunk2 };
		IChunk[] lsdmfocwChunks = lsdmfocwRule.invoke(chunks);
		assertEquals(chunk1, lsdmfocwChunks[0]);
	}

}
