/**
 * 
 */
package org.solol.mmseg.test;

import junit.framework.TestCase;

import org.solol.mmseg.core.IChunk;
import org.solol.mmseg.core.IRule;
import org.solol.mmseg.core.IWord;
import org.solol.mmseg.internal.Chunk;
import org.solol.mmseg.internal.SVWLRule;
import org.solol.mmseg.internal.Word;

/**
 * @author solo L
 * 
 */
public class SVWLRuleTest extends TestCase {

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		super.setUp();
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see junit.framework.TestCase#tearDown()
	 */
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/**
	 * Test method for
	 * {@link org.solol.mmseg.internal.SVWLRule#invoke(org.solol.mmseg.core.IChunk[])}.
	 */
	public final void testInvoke() {
		IWord word1 = new Word("研究",Word.CJK_WORD);
		IWord word2 = new Word("生命",Word.CJK_WORD);
		IWord word3 = new Word("起源",Word.CJK_WORD);
		IWord word4 = new Word("研究生",Word.CJK_WORD);
		IWord word5 = new Word("命",Word.CJK_WORD);

		IChunk chunk1 = new Chunk(new IWord[] { word1, word2, word3 });
		IChunk chunk2 = new Chunk(new IWord[] { word4, word5, word3 });

		IRule svwlRule = new SVWLRule();
		IChunk[] chunks = new IChunk[] { chunk1, chunk2 };
		IChunk[] svwlChunks = svwlRule.invoke(chunks);
		assertEquals(chunk1, svwlChunks[0]);
	}

}
